'**************************************************************************
'*                       Multimedia MasterClass Install
'**************************************************************************

'$DEFINE DEBUG  ''Define for script development/debugging

'$INCLUDE 'setupapi.inc'
'$INCLUDE 'msdetect.inc'

''Dialog ID's
CONST DLG_DETECT      = 27
CONST WELCOME         = 100
CONST ASKQUIT         = 200
CONST DESTPATH        = 300
CONST EXITFAILURE     = 400
CONST EXITQUIT        = 600
CONST EXITSUCCESS     = 700
CONST OPTIONS         = 800
CONST APPHELP         = 900
CONST CUSTINST        = 6200
CONST TOOBIG          = 6300
CONST BADPATH         = 6400
CONST CDBADFILE       = 7200
CONST TAPE_SOURCE     = 7900

''PRB - To maximise window
CONST WS_VISIBLE       = &H10000000
CONST WS_BORDER        = &H00800000
CONST WS_CLIPCHILDREN  = &H02000000
CONST GWL_STYLE        = -16
CONST SW_SHOWMAXIMIZED = 3

''Bitmap ID
CONST LOGO   = 1

''File Types
CONST APPFILES     = 1
CONST OPTFILES1    = 2
CONST OPTFILES2    = 3
CONST OPTFILES3    = 4

GLOBAL LF_STATUS$

GLOBAL DEST$        ''Default destination directory.
GLOBAL WINDRIVE$    ''Windows drive letter.

''CustInst list symbol names
GLOBAL APPNEEDS$    ''Option list costs per drive
GLOBAL OPT1NEEDS$
GLOBAL OPT2NEEDS$
GLOBAL OPT3NEEDS$
GLOBAL EXTRACOSTS$  ''List of extra costs to add per drive
GLOBAL BIGLIST$     ''List of option files cost calc results (boolean)

''Dialog list symbol names
GLOBAL CHECKSTATES$
GLOBAL STATUSTEXT$
GLOBAL DRIVETEXT$


DECLARE SUB AddOptFilesToCopyList (ftype%)
DECLARE SUB RecalcOptFiles (ftype%)
DECLARE SUB RecalcPath
DECLARE SUB SetDriveStatus
DECLARE FUNCTION MakePath (szDir$, szFile$) AS STRING

''PRB - To maximise window
DECLARE FUNCTION ShowWindow  LIB "user.exe" (hWnd%,iShow%) AS INTEGER
DECLARE FUNCTION SetWindowLong LIB "user.exe" (hWnd%, offset%, style&) AS LONG


INIT:
    ''PRB - To maximise window
    hWnd%=HwndFrame()
    x&=SetWindowLong(hWnd%,GWL_STYLE,WS_VISIBLE+WS_BORDER+WS_CLIPCHILDREN)
    y%=ShowWindow(hWnd%,SW_SHOWMAXIMIZED)

    CUIDLL$ = "mc_inst.dll"            ''custom user interface dll
    HELPPROC$ = "FHelpDlgProc"          ''Help dialog procedure

    SetBitmap CUIDLL$, LOGO
    SetTitle "Multimedia MasterClass Setup"

    szInf$ = GetSymbolValue("STF_SRCINFPATH")
    IF szInf$ = "" THEN
	szInf$ = GetSymbolValue("STF_CWDDIR") + "MC_INST.INF"
    END IF
    ReadInfFile szInf$

    WINDRIVE$ = MID$(GetWindowsDir, 1, 1)
    DEST$ = WINDRIVE$ + ":\MCLASS"

    ''CustInst list symbols
    CHECKSTATES$ = "CheckItemsState"
    STATUSTEXT$  = "StatusItemsText"
    DRIVETEXT$   = "DriveStatusText"
    FOR i% = 1 TO 5 STEP 1
	AddListItem CHECKSTATES$, "ON"
    NEXT i%
    FOR i% = 1 TO 5 STEP 1
        AddListItem STATUSTEXT$, ""
    NEXT i%
    FOR i% = 1 TO 7 STEP 1
        AddListItem DRIVETEXT$, ""
    NEXT i%
    ReplaceListItem DRIVETEXT$, 7, DEST$

    ''Disk cost list symbols
    APPNEEDS$   = "AppNeeds"
    OPT1NEEDS$  = "Opt1Needs"
    OPT2NEEDS$  = "Opt2Needs"
    OPT3NEEDS$  = "Opt3Needs"
    EXTRACOSTS$ = "ExtraCosts"
    BIGLIST$    = "BigList"
    FOR i% = 1 TO 5 STEP 1
        AddListItem BIGLIST$, ""
    NEXT i%
    FOR i% = 1 TO 26 STEP 1
	AddListItem EXTRACOSTS$, "0"
    NEXT i%

    RecalcPath
    SetDriveStatus

'$IFDEF DEBUG
    i% = SetSizeCheckMode(scmOnIgnore)    '' could use scmOff; def = scmOnFatal
'$ENDIF ''DEBUG


WELCOME:
    sz$ = UIStartDlg(CUIDLL$, WELCOME, "FInfoDlgProc", APPHELP, HELPPROC$)
    IF sz$ = "CONTINUE" THEN
	UIPop 1
    ELSE
	GOSUB ASKQUIT
	GOTO WELCOME
    END IF


GETPATH:
    SetSymbolValue "EditTextIn", DEST$
    SetSymbolValue "EditFocus", "END"
GETPATHL1:
    sz$ = UIStartDlg(CUIDLL$, DESTPATH, "FEditDlgProc", APPHELP, HELPPROC$)

    IF sz$ = "CONTINUE" THEN
	olddest$ = DEST$
	DEST$ = GetSymbolValue("EditTextOut")

	''Validate new path.
	IF IsDirWritable(DEST$) = 0 THEN
	    GOSUB BADPATH
	    GOTO GETPATHL1
	END IF
	UIPop 1

	''Truncate display if too long.
	IF LEN(DEST$) > 23 THEN
	    ReplaceListItem DRIVETEXT$, 7, MID$(DEST$, 1, 23)+"..."
	ELSE
	    ReplaceListItem DRIVETEXT$, 7, DEST$
	END IF

	''Recalc if path changed.
	IF (olddest$ <> DEST$) AND (olddest$ <> DEST$+"\") AND (olddest$+"\" <> DEST$) THEN
	    RecalcPath
	    SetDriveStatus
	END IF

	olddest$ = ""
    ELSEIF sz$ = "REACTIVATE" THEN
	RecalcPath
	SetDriveStatus
	GOTO GETPATHL1
    ELSEIF sz$ = "BACK" THEN
	UIPop 1
	GOTO WELCOME
    ELSEIF sz$ = "EXIT" THEN
        GOSUB ASKQUIT
        GOTO GETPATHL1
    ELSE
	UIPop 1
    END IF




CUSTINST:
    SetSymbolValue "EditTextIn", DEST$

CUSTINSTL1:
    sz$ = UIStartDlg(CUIDLL$, CUSTINST, "FCustInstDlgProc", APPHELP, HELPPROC$)

    IF sz$ = "CONTINUE" THEN
        ''Install only if it will fit.
        FOR i% = 1 TO 5 STEP 1
            IF GetListItem(BIGLIST$, i%) <> "" THEN
		GOSUB TOOBIG
                GOTO GETPATH
            END IF
        NEXT i%
	UIPop 1
	GOTO INSTALL
    ELSEIF sz$ = "BACK" THEN
	UIPop 1
	GOTO GETPATH
    ELSEIF sz$ = "CHK1" THEN
	RecalcOptFiles APPFILES
	SetDriveStatus
	GOTO CUSTINSTL1
    ELSEIF sz$ = "CHK2" THEN
	RecalcOptFiles OPTFILES1
	SetDriveStatus
	GOTO CUSTINSTL1
    ELSEIF sz$ = "CHK3" THEN
	RecalcOptFiles OPTFILES2
	SetDriveStatus
	GOTO CUSTINSTL1
    ELSEIF sz$ = "CHK4" THEN
	RecalcOptFiles OPTFILES3
	SetDriveStatus
	GOTO CUSTINSTL1
    ELSEIF sz$ = "REACTIVATE" THEN
	RecalcPath
	SetDriveStatus
	GOTO CUSTINSTL1
    ELSE
	GOSUB ASKQUIT
	GOTO CUSTINSTL1
    END IF



INSTALL:
    SetSymbolValue "LFName", LF_NAME$

    ClearCopyList
    AddOptFilesToCopyList APPFILES
    AddOptFilesToCopyList OPTFILES1
    AddOptFilesToCopyList OPTFILES2
    AddOptFilesToCopyList OPTFILES3
    CreateDir DEST$, cmoNone
    CopyFilesInCopyList

    CreateProgmanGroup "Multimedia MasterClass", "", cmoNone
    ShowProgmanGroup  "Multimedia MasterClass", 1, cmoNone
    CreateProgmanItem "Multimedia MasterClass", "Demo User Guide", "WRITE.EXE "+MakePath(DEST$,"mcldemo.wri"), "", cmoOverwrite


    IF GetListItem(CHECKSTATES$, APPFILES) = "ON" THEN
      CreateProgmanItem "Multimedia MasterClass", "MasterClass Developer Demo", MakePath(DEST$,"mclass.exe"), ",1,1,1,", cmoOverwrite
    END IF

'    IF GetListItem(CHECKSTATES$, OPTFILES3) = "ON" THEN
'      CreateProgmanItem "Multimedia MasterClass", "16 Colour Demo", MakePath(DEST$,"mclrun.exe ")+MakePath(DEST$,"EXAMPLES\DEMO16.MCL"), "", cmoOverwrite
'      CreateProgmanItem "Multimedia MasterClass", "256 Colour Demo", MakePath(DEST$,"mclrun.exe ")+MakePath(DEST$,"EXAMPLES\DEMO256.MCL"), "", cmoOverwrite
'    END IF

    IF GetListItem(CHECKSTATES$, OPTFILES1) = "ON" THEN
      CreateProgmanItem "Multimedia MasterClass", "MasterClass Help", "WINHELP.EXE "+MakePath(DEST$,"mclass.hlp"), "", cmoOverwrite
    END IF


MC_SETTINGS:
    SetSymbolValue "IniPath", DEST$

MC_SETTINGSL1:
    sz$ = UIStartDlg(CUIDLL$, TAPE_SOURCE, "CustomDlgProc", APPHELP, HELPPROC$)
    IF sz$ = "CONTINUE" THEN
	UIPop 1
    ELSE
	UIPop 1
	GOSUB ASKQUIT
	GOTO MC_SETTINGSL1
    END IF




QUIT:
    ON ERROR GOTO ERRQUIT

    IF ERR = 0 THEN
	dlg% = EXITSUCCESS
    ELSEIF ERR = STFQUIT THEN
        dlg% = EXITQUIT
    ELSE
        dlg% = EXITFAILURE
    END IF
QUITL1:
    sz$ = UIStartDlg(CUIDLL$, dlg%, "FInfo0DlgProc", 0, "")
    IF sz$ = "REACTIVATE" THEN
	GOTO QUITL1
    END IF
    UIPop 1

    END

ERRQUIT:
    i% = DoMsgBox("Setup sources were corrupted!", "Setup Message", MB_OK+MB_TASKMODAL+MB_ICONHAND)
    END



TOOBIG:
    sz$ = UIStartDlg(CUIDLL$, TOOBIG, "FInfo0DlgProc", 0, "")
    IF sz$ = "REACTIVATE" THEN
        RecalcPath
        SetDriveStatus
        GOTO TOOBIG
    END IF
    UIPop 1
    RETURN



BADPATH:
    sz$ = UIStartDlg(CUIDLL$, BADPATH, "FInfo0DlgProc", 0, "")
    IF sz$ = "REACTIVATE" THEN
        RecalcPath
        SetDriveStatus
	GOTO BADPATH
    END IF
    UIPop 1
    RETURN



ASKQUIT:
    sz$ = UIStartDlg(CUIDLL$, ASKQUIT, "FQuitDlgProc", 0, "")

    IF sz$ = "EXIT" THEN
        UIPopAll
        ERROR STFQUIT
    ELSEIF sz$ = "REACTIVATE" THEN
        GOTO ASKQUIT
    ELSE
        UIPop 1
    END IF
    RETURN



'**
'** Purpose:
'**     Adds the specified option files to the copy list.
'** Arguments:
'**     ftype%  - type of files to add, one of the following:
'**             APPFILES, OPTFILES1, OPTFILES2
'** Returns:
'**     none.
'*************************************************************************
SUB AddOptFilesToCopyList (ftype%) STATIC

    IF GetListItem(CHECKSTATES$, ftype%) = "ON" THEN
        SrcDir$ = GetSymbolValue("STF_SRCDIR")
	IF ftype% = APPFILES THEN
	    AddSectionFilesToCopyList "AppFiles", SrcDir$, DEST$
        ELSEIF ftype% = OPTFILES1 THEN
	    AddSectionFilesToCopyList "OptFiles1", SrcDir$, DEST$
	ELSEIF ftype% = OPTFILES2 THEN
            AddSectionFilesToCopyList "OptFiles2", SrcDir$, DEST$
	ELSEIF ftype% = OPTFILES3 THEN
            AddSectionFilesToCopyList "OptFiles3", SrcDir$, DEST$
	END IF
        SrcDir$ = ""
    END IF
END SUB


'**
'** Purpose:
'**     Recalculates disk space for the given option files and sets
'**     the status info symbol "StatusItemsText".
'** Arguments:
'**     ftype% - type of files to add, one of the following:
'**             APPFILES, OPTFILES1, OPTFILES2
'** Returns:
'**     none.
'*************************************************************************
SUB RecalcOptFiles (ftype%) STATIC
    CursorSave% = ShowWaitCursor()
    ClearCopyList
    AddOptFilesToCopyList ftype%

    fExtra% = 0
    IF ftype% = APPFILES THEN
        ListSym$ = APPNEEDS$
        IF GetListItem(CHECKSTATES$, APPFILES) = "ON" THEN
            ''Add extra cost to Windows drive for ini/progman, etc.
            ndrive% = ASC(ucase$(WINDRIVE$)) - ASC("A") + 1
	    ''ReplaceListItem EXTRACOSTS$, ndrive%, "10240"
	    ReplaceListItem EXTRACOSTS$, ndrive%, "0"
	    fExtra% = 1
        END IF
    ELSEIF ftype% = OPTFILES1 THEN
        ListSym$ = OPT1NEEDS$
    ELSEIF ftype% = OPTFILES2 THEN
        ListSym$ = OPT2NEEDS$
    ELSEIF ftype% = OPTFILES3 THEN
        ListSym$ = OPT3NEEDS$
    END IF

    StillNeed& = GetCopyListCost(EXTRACOSTS$, ListSym$, "")

    cost& = 0
    FOR i% = 1 TO 26 STEP 1
        cost&  = cost& + VAL(GetListItem(ListSym$, i%))
    NEXT i%
    ReplaceListItem STATUSTEXT$, ftype%, STR$(cost& / 1024) + " K"

    IF StillNeed& > 0 THEN
        ReplaceListItem BIGLIST$, ftype%, "YES"
    ELSE
        ReplaceListItem BIGLIST$, ftype%, ""
    END IF

    IF fExtra% THEN
        ReplaceListItem EXTRACOSTS$, ndrive%, "0"
    END IF
    RestoreCursor CursorSave%
    ListSym$ = ""
END SUB


'**
'** Purpose:
'**     Recalculates disk space and sets option status info according
'**     to the current destination path.
'** Arguments:
'**     none.
'** Returns:
'**     none.
'*************************************************************************
SUB RecalcPath STATIC

    CursorSave% = ShowWaitCursor()

    RecalcOptFiles APPFILES
    RecalcOptFiles OPTFILES1
    RecalcOptFiles OPTFILES2
    RecalcOptFiles OPTFILES3

    RestoreCursor CursorSave%
END SUB


'**
'** Purpose:
'**     Sets drive status info according to latest disk space calcs.
'** Arguments:
'**     none.
'** Returns:
'**     none.
'*************************************************************************
SUB SetDriveStatus STATIC

    drive$ = MID$(DEST$, 1, 1)
    ndrive% = ASC(ucase$(drive$)) - ASC("A") + 1
    cost& = VAL(GetListItem(APPNEEDS$, ndrive%)) + VAL(GetListItem(OPT1NEEDS$, ndrive%)) + VAL(GetListItem(OPT2NEEDS$, ndrive%)) + VAL(GetListItem(OPT3NEEDS$, ndrive%))
    free& = GetFreeSpaceForDrive(drive$)
    ReplaceListItem DRIVETEXT$, 1, drive$ + ":"
    ReplaceListItem DRIVETEXT$, 2, STR$(cost& / 1024) + " K"
    ReplaceListItem DRIVETEXT$, 3, STR$(free& / 1024) + " K"

    IF drive$ = WINDRIVE$ THEN
        ReplaceListItem DRIVETEXT$, 4, ""
        ReplaceListItem DRIVETEXT$, 5, ""
        ReplaceListItem DRIVETEXT$, 6, ""
    ELSE
        ndrive% = ASC(ucase$(WINDRIVE$)) - ASC("A") + 1
	cost& = VAL(GetListItem(APPNEEDS$, ndrive%)) + VAL(GetListItem(OPT1NEEDS$, ndrive%)) + VAL(GetListItem(OPT2NEEDS$, ndrive%)) + VAL(GetListItem(OPT3NEEDS$, ndrive%))
	IF cost& = 0 THEN
            ReplaceListItem DRIVETEXT$, 4, ""
            ReplaceListItem DRIVETEXT$, 5, ""
            ReplaceListItem DRIVETEXT$, 6, ""
        ELSE
            free& = GetFreeSpaceForDrive(WINDRIVE$)
            ReplaceListItem DRIVETEXT$, 4, WINDRIVE$ + ":"
            ReplaceListItem DRIVETEXT$, 5, STR$(cost& / 1024) + " K"
            ReplaceListItem DRIVETEXT$, 6, STR$(free& / 1024) + " K"
        END IF
    END IF
END SUB


'**
'** Purpose:
'**     Appends a file name to the end of a directory path,
'**     inserting a backslash character as needed.
'** Arguments:
'**     szDir$  - full directory path (with optional ending "\")
'**     szFile$ - filename to append to directory
'** Returns:
'**     Resulting fully qualified path name.
'*************************************************************************
FUNCTION MakePath (szDir$, szFile$) STATIC AS STRING
    IF szDir$ = "" THEN
        MakePath = szFile$
    ELSEIF szFile$ = "" THEN
        MakePath = szDir$
    ELSEIF MID$(szDir$, LEN(szDir$), 1) = "\" THEN
        MakePath = szDir$ + szFile$
    ELSE
        MakePath = szDir$ + "\" + szFile$
    END IF
END FUNCTION

